import windows;
import winbase;
import wingdi;
import c.stdio;
//import c.stdlib;

public:

enum
{
  WS_OVERLAPPED      = 0x00000000L,
  WS_POPUP           = 0x80000000L,
  WS_CHILD           = 0x40000000L,
  WS_MINIMIZE        = 0x20000000L,
  WS_VISIBLE         = 0x10000000L,
  WS_DISABLED        = 0x08000000L,
  WS_CLIPSIBLINGS    = 0x04000000L,
  WS_CLIPCHILDREN    = 0x02000000L,
  WS_MAXIMIZE        = 0x01000000L,
  WS_CAPTION         = 0x00C00000L,     // WS_BORDER | WS_DLGFRAME
  WS_BORDER          = 0x00800000L,
  WS_DLGFRAME        = 0x00400000L,
  WS_VSCROLL         = 0x00200000L,
  WS_HSCROLL         = 0x00100000L,
  WS_SYSMENU         = 0x00080000L,
  WS_THICKFRAME      = 0x00040000L,
  WS_GROUP           = 0x00020000L,
  WS_TABSTOP         = 0x00010000L,

  WS_MINIMIZEBOX     = 0x00020000L,
  WS_MAXIMIZEBOX     = 0x00010000L,

  WS_TILED           = WS_OVERLAPPED,
  WS_ICONIC          = WS_MINIMIZE,
  WS_SIZEBOX         = WS_THICKFRAME,

  // Common Window Styles
  WS_OVERLAPPEDWINDOW = WS_OVERLAPPED     |
                             WS_CAPTION        |
                             WS_SYSMENU        |
                             WS_THICKFRAME     |
                             WS_MINIMIZEBOX    |
                             WS_MAXIMIZEBOX,
  WS_TILEDWINDOW     = WS_OVERLAPPEDWINDOW,

  WS_POPUPWINDOW     = WS_POPUP          |
                             WS_BORDER         |
                             WS_SYSMENU,

  WS_CHILDWINDOW     = WS_CHILD,

  // Extended Window Styles
  WS_EX_DLGMODALFRAME    = 0x00000001L,
  WS_EX_NOPARENTNOTIFY   = 0x00000004L,
  WS_EX_TOPMOST          = 0x00000008L,
  WS_EX_ACCEPTFILES      = 0x00000010L,
  WS_EX_TRANSPARENT      = 0x00000020L,

  WS_EX_MDICHILD         = 0x00000040L,
  WS_EX_TOOLWINDOW       = 0x00000080L,
  WS_EX_WINDOWEDGE       = 0x00000100L,
  WS_EX_CLIENTEDGE       = 0x00000200L,
  WS_EX_CONTEXTHELP      = 0x00000400L,

  WS_EX_RIGHT            = 0x00001000L,
  WS_EX_LEFT             = 0x00000000L,
  WS_EX_RTLREADING       = 0x00002000L,
  WS_EX_LTRREADING       = 0x00000000L,
  WS_EX_LEFTSCROLLBAR    = 0x00004000L,
  WS_EX_RIGHTSCROLLBAR   = 0x00000000L,

  WS_EX_CONTROLPARENT    = 0x00010000L,
  WS_EX_STATICEDGE       = 0x00020000L,
  WS_EX_APPWINDOW        = 0x00040000L,

  WS_EX_OVERLAPPEDWINDOW = WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE,
  WS_EX_PALETTEWINDOW    = WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST,
}



enum
{
  CS_VREDRAW         = 0x0001,
  CS_HREDRAW         = 0x0002,
  CS_KEYCVTWINDOW    = 0x0004,
  CS_DBLCLKS         = 0x0008,
  CS_OWNDC           = 0x0020,
  CS_CLASSDC         = 0x0040,
  CS_PARENTDC        = 0x0080,
  CS_NOKEYCVT        = 0x0100,
  CS_NOCLOSE         = 0x0200,
  CS_SAVEBITS        = 0x0800,
  CS_BYTEALIGNCLIENT = 0x1000,
  CS_BYTEALIGNWINDOW = 0x2000,
  CS_GLOBALCLASS     = 0x4000,
}

enum
{
  WM_NULL                        = 0x0000,
  WM_CREATE                      = 0x0001,
  WM_DESTROY                     = 0x0002,
  WM_MOVE                        = 0x0003,
  WM_SIZE                        = 0x0005,
  SIZE_RESTORED       = 0,
  SIZE_MINIMIZED      = 1,
  SIZE_MAXIMIZED      = 2,
  SIZE_MAXSHOW        = 3,
  SIZE_MAXHIDE        = 4,
  SIZENORMAL          = SIZE_RESTORED,
  SIZEICONIC          = SIZE_MINIMIZED,
  SIZEFULLSCREEN      = SIZE_MAXIMIZED,
  SIZEZOOMSHOW        = SIZE_MAXSHOW,
  SIZEZOOMHIDE        = SIZE_MAXHIDE,

  WM_ACTIVATE                    = 0x0006,

  WM_SETFOCUS                    = 0x0007,
  WM_KILLFOCUS                   = 0x0008,
  WM_ENABLE                      = 0x000A,
  WM_SETREDRAW                   = 0x000B,
  WM_SETTEXT                     = 0x000C,
  WM_GETTEXT                     = 0x000D,
  WM_GETTEXTLENGTH               = 0x000E,
  WM_PAINT                       = 0x000F,
  WM_CLOSE                       = 0x0010,
  WM_QUERYENDSESSION             = 0x0011,
  WM_QUIT                        = 0x0012,
  WM_QUERYOPEN                   = 0x0013,
  WM_ERASEBKGND                  = 0x0014,
  WM_SYSCOLORCHANGE              = 0x0015,
  WM_ENDSESSION                  = 0x0016,
  WM_SHOWWINDOW                  = 0x0018,
  WM_WININICHANGE                = 0x001A,
  WM_SETTINGCHANGE               = WM_WININICHANGE,

  WM_DEVMODECHANGE               = 0x001B,
  WM_ACTIVATEAPP                 = 0x001C,
  WM_FONTCHANGE                  = 0x001D,
  WM_TIMECHANGE                  = 0x001E,
  WM_CANCELMODE                  = 0x001F,
  WM_SETCURSOR                   = 0x0020,
  WM_MOUSEACTIVATE               = 0x0021,
  WM_CHILDACTIVATE               = 0x0022,
  WM_QUEUESYNC                   = 0x0023,

  WM_GETMINMAXINFO               = 0x0024,

  WM_PAINTICON                   = 0x0026,
  WM_ICONERASEBKGND              = 0x0027,
  WM_NEXTDLGCTL                  = 0x0028,
  WM_SPOOLERSTATUS               = 0x002A,
  WM_DRAWITEM                    = 0x002B,
  WM_MEASUREITEM                 = 0x002C,
  WM_DELETEITEM                  = 0x002D,
  WM_VKEYTOITEM                  = 0x002E,
  WM_CHARTOITEM                  = 0x002F,
  WM_SETFONT                     = 0x0030,
  WM_GETFONT                     = 0x0031,
  WM_SETHOTKEY                   = 0x0032,
  WM_GETHOTKEY                   = 0x0033,
  WM_QUERYDRAGICON               = 0x0037,
  WM_COMPAREITEM                 = 0x0039,

  WM_COMPACTING                  = 0x0041,
  WM_WINDOWPOSCHANGING           = 0x0046,
  WM_WINDOWPOSCHANGED            = 0x0047,

  WM_POWER                       = 0x0048,

  WM_COPYDATA                    = 0x004A,
  WM_CANCELJOURNAL               = 0x004B,

  WM_NOTIFY                      = 0x004E,
  WM_INPUTLANGCHANGEREQUEST      = 0x0050,
  WM_INPUTLANGCHANGE             = 0x0051,
  WM_TCARD                       = 0x0052,
  WM_HELP                        = 0x0053,
  WM_USERCHANGED                 = 0x0054,
  WM_NOTIFYFORMAT                = 0x0055,

  WM_CONTEXTMENU                 = 0x007B,
  WM_STYLECHANGING               = 0x007C,
  WM_STYLECHANGED                = 0x007D,
  WM_DISPLAYCHANGE               = 0x007E,
  WM_GETICON                     = 0x007F,
  WM_SETICON                     = 0x0080,

  WM_NCCREATE                    = 0x0081,
  WM_NCDESTROY                   = 0x0082,
  WM_NCCALCSIZE                  = 0x0083,
  WM_NCHITTEST                   = 0x0084,
  WM_NCPAINT                     = 0x0085,
  WM_NCACTIVATE                  = 0x0086,
  WM_GETDLGCODE                  = 0x0087,

  WM_NCMOUSEMOVE                 = 0x00A0,
  WM_NCLBUTTONDOWN               = 0x00A1,
  WM_NCLBUTTONUP                 = 0x00A2,
  WM_NCLBUTTONDBLCLK             = 0x00A3,
  WM_NCRBUTTONDOWN               = 0x00A4,
  WM_NCRBUTTONUP                 = 0x00A5,
  WM_NCRBUTTONDBLCLK             = 0x00A6,
  WM_NCMBUTTONDOWN               = 0x00A7,
  WM_NCMBUTTONUP                 = 0x00A8,
  WM_NCMBUTTONDBLCLK             = 0x00A9,

  WM_KEYFIRST                    = 0x0100,
  WM_KEYDOWN                     = 0x0100,
  WM_KEYUP                       = 0x0101,
  WM_CHAR                        = 0x0102,
  WM_DEADCHAR                    = 0x0103,
  WM_SYSKEYDOWN                  = 0x0104,
  WM_SYSKEYUP                    = 0x0105,
  WM_SYSCHAR                     = 0x0106,
  WM_SYSDEADCHAR                 = 0x0107,
  WM_KEYLAST                     = 0x0108,

  WM_IME_STARTCOMPOSITION        = 0x010D,
  WM_IME_ENDCOMPOSITION          = 0x010E,
  WM_IME_COMPOSITION             = 0x010F,
  WM_IME_KEYLAST                 = 0x010F,

  WM_INITDIALOG                  = 0x0110,
  WM_COMMAND                     = 0x0111,
  WM_SYSCOMMAND                  = 0x0112,

  SC_SIZE         = 0xF000,
  SC_MOVE         = 0xF010,
  SC_MINIMIZE     = 0xF020,
  SC_MAXIMIZE     = 0xF030,
  SC_NEXTWINDOW   = 0xF040,
  SC_PREVWINDOW   = 0xF050,
  SC_CLOSE        = 0xF060,
  SC_VSCROLL      = 0xF070,
  SC_HSCROLL      = 0xF080,
  SC_MOUSEMENU    = 0xF090,
  SC_KEYMENU      = 0xF100,
  SC_ARRANGE      = 0xF110,
  SC_RESTORE      = 0xF120,
  SC_TASKLIST     = 0xF130,
  SC_SCREENSAVE   = 0xF140,
  SC_HOTKEY       = 0xF150,
  SC_DEFAULT      = 0xF160,
  SC_MONITORPOWER = 0xF170,
  SC_CONTEXTHELP  = 0xF180,
  SC_SEPARATOR    = 0xF00F,
  SC_ICON         = SC_MINIMIZE,
  SC_ZOOM         = SC_MAXIMIZE,

  WM_TIMER                       = 0x0113,
  WM_HSCROLL                     = 0x0114,
  WM_VSCROLL                     = 0x0115,
  WM_INITMENU                    = 0x0116,
  WM_INITMENUPOPUP               = 0x0117,
  WM_MENUSELECT                  = 0x011F,
  WM_MENUCHAR                    = 0x0120,
  WM_ENTERIDLE                   = 0x0121,

  WM_CTLCOLORMSGBOX              = 0x0132,
  WM_CTLCOLOREDIT                = 0x0133,
  WM_CTLCOLORLISTBOX             = 0x0134,
  WM_CTLCOLORBTN                 = 0x0135,
  WM_CTLCOLORDLG                 = 0x0136,
  WM_CTLCOLORSCROLLBAR           = 0x0137,
  WM_CTLCOLORSTATIC              = 0x0138,

  WM_MOUSEFIRST                  = 0x0200,
  WM_MOUSEMOVE                   = 0x0200,
  WM_LBUTTONDOWN                 = 0x0201,
  WM_LBUTTONUP                   = 0x0202,
  WM_LBUTTONDBLCLK               = 0x0203,
  WM_RBUTTONDOWN                 = 0x0204,
  WM_RBUTTONUP                   = 0x0205,
  WM_RBUTTONDBLCLK               = 0x0206,
  WM_MBUTTONDOWN                 = 0x0207,
  WM_MBUTTONUP                   = 0x0208,
  WM_MBUTTONDBLCLK               = 0x0209,
  WM_MOUSEWHEEL                  = 0x020A,
  WM_MOUSELAST                   = 0x020A,

  WHEEL_DELTA                    = 120,     // Value for rolling one detent
  WHEEL_PAGESCROLL               = 0xffffffff, // Scroll one page

  WM_PARENTNOTIFY                = 0x0210,
  MENULOOP_WINDOW                = 0,
  MENULOOP_POPUP                 = 1,
  WM_ENTERMENULOOP               = 0x0211,
  WM_EXITMENULOOP                = 0x0212,

  WM_NEXTMENU                    = 0x0213,

  WM_SIZING                      = 0x0214,
  WM_CAPTURECHANGED              = 0x0215,
  WM_MOVING                      = 0x0216,
  WM_POWERBROADCAST              = 0x0218,
  WM_DEVICECHANGE                = 0x0219,

  WM_IME_SETCONTEXT              = 0x0281,
  WM_IME_NOTIFY                  = 0x0282,
  WM_IME_CONTROL                 = 0x0283,
  WM_IME_COMPOSITIONFULL         = 0x0284,
  WM_IME_SELECT                  = 0x0285,
  WM_IME_CHAR                    = 0x0286,
  WM_IME_KEYDOWN                 = 0x0290,
  WM_IME_KEYUP                   = 0x0291,

  WM_MDICREATE                   = 0x0220,
  WM_MDIDESTROY                  = 0x0221,
  WM_MDIACTIVATE                 = 0x0222,
  WM_MDIRESTORE                  = 0x0223,
  WM_MDINEXT                     = 0x0224,
  WM_MDIMAXIMIZE                 = 0x0225,
  WM_MDITILE                     = 0x0226,
  WM_MDICASCADE                  = 0x0227,
  WM_MDIICONARRANGE              = 0x0228,
  WM_MDIGETACTIVE                = 0x0229,

  WM_MDISETMENU                  = 0x0230,
  WM_ENTERSIZEMOVE               = 0x0231,
  WM_EXITSIZEMOVE                = 0x0232,
  WM_DROPFILES                   = 0x0233,
  WM_MDIREFRESHMENU              = 0x0234,

  WM_MOUSEHOVER                  = 0x02A1,
  WM_MOUSELEAVE                  = 0x02A3,

  WM_CUT                         = 0x0300,
  WM_COPY                        = 0x0301,
  WM_PASTE                       = 0x0302,
  WM_CLEAR                       = 0x0303,
  WM_UNDO                        = 0x0304,
  WM_RENDERFORMAT                = 0x0305,
  WM_RENDERALLFORMATS            = 0x0306,
  WM_DESTROYCLIPBOARD            = 0x0307,
  WM_DRAWCLIPBOARD               = 0x0308,
  WM_PAINTCLIPBOARD              = 0x0309,
  WM_VSCROLLCLIPBOARD            = 0x030A,
  WM_SIZECLIPBOARD               = 0x030B,
  WM_ASKCBFORMATNAME             = 0x030C,
  WM_CHANGECBCHAIN               = 0x030D,
  WM_HSCROLLCLIPBOARD            = 0x030E,
  WM_QUERYNEWPALETTE             = 0x030F,
  WM_PALETTEISCHANGING           = 0x0310,
  WM_PALETTECHANGED              = 0x0311,
  WM_HOTKEY                      = 0x0312,

  WM_PRINT                       = 0x0317,
  WM_PRINTCLIENT                 = 0x0318,

  WM_HANDHELDFIRST               = 0x0358,
  WM_HANDHELDLAST                = 0x035F,

  WM_AFXFIRST                    = 0x0360,
  WM_AFXLAST                     = 0x037F,

  WM_PENWINFIRST                 = 0x0380,
  WM_PENWINLAST                  = 0x038F,

  WM_APP                         = 0x8000,
}

struct WNDCLASSA
{
  UINT        style;
  WNDPROC     lpfnWndProc;
  int         cbClsExtra;
  int         cbWndExtra;
  HINSTANCE   hInstance;
  HICON       hIcon;
  HCURSOR     hCursor;
  HBRUSH      hbrBackground;
  LPCSTR      lpszMenuName;
  LPCSTR      lpszClassName;
}
alias WNDCLASSA* PWNDCLASSA;
alias WNDCLASSA* NPWNDCLASSA;
alias WNDCLASSA* LPWNDCLASSA;

struct WNDCLASSW
{
  UINT        style;
  WNDPROC     lpfnWndProc;
  int         cbClsExtra;
  int         cbWndExtra;
  HINSTANCE   hInstance;
  HICON       hIcon;
  HCURSOR     hCursor;
  HBRUSH      hbrBackground;
  LPCWSTR     lpszMenuName;
  LPCWSTR     lpszClassName;
}

alias WNDCLASSW* PWNDCLASSW;
alias WNDCLASSW* NPWNDCLASSW;
alias WNDCLASSW* LPWNDCLASSW;

version(unicode)
{
  alias WNDCLASSW WNDCLASS;
  alias PWNDCLASSW PWNDCLASS;
  alias NPWNDCLASSW NPWNDCLASS;
  alias LPWNDCLASSW LPWNDCLASS;
}
else
{
  alias WNDCLASSA WNDCLASS;
  alias PWNDCLASSA PWNDCLASS;
  alias NPWNDCLASSA NPWNDCLASS;
  alias LPWNDCLASSA LPWNDCLASS;
}

extern(Windows)
{
  typedef LRESULT (* WNDPROC)(HWND, UINT, WPARAM, LPARAM);
}

alias int WPARAM;
alias int LPARAM;
alias int LRESULT;

int MAKELONG(int l, int h) { return (l&0xffff) | (h<<16); }
WPARAM MAKEWPARAM(int l, int h) { return cast(WPARAM) MAKELONG(l, h); }
LPARAM MAKELPARAM(int l, int h) { return cast(LPARAM) MAKELONG(l, h); }
LRESULT MAKELRESULT(int l, int h) { return cast(LRESULT) MAKELONG(l, h); }
//int LOWORD(int l) { return l&0xffff; }
//int HIWORD(int l) { return l>>16; }

struct ACCEL
{
  BYTE   fVirt;               // Also called the flags field
  WORD   key;
  WORD   cmd;
}
alias ACCEL* LPACCEL;

struct PAINTSTRUCT
{
  HDC         hdc;
  BOOL        fErase;
  RECT        rcPaint;
  BOOL        fRestore;
  BOOL        fIncUpdate;
  BYTE        rgbReserved[32];
}
alias PAINTSTRUCT* PPAINTSTRUCT;
alias PAINTSTRUCT* NPPAINTSTRUCT;
alias PAINTSTRUCT* LPPAINTSTRUCT;

struct CREATESTRUCTW
{
  LPVOID      lpCreateParams;
  HINSTANCE   hInstance;
  HMENU       hMenu;
  HWND        hwndParent;
  int         cy;
  int         cx;
  int         y;
  int         x;
  LONG        style;
  LPCWSTR     lpszName;
  LPCWSTR     lpszClass;
  DWORD       dwExStyle;
}
alias CREATESTRUCTW* LPCREATESTRUCTW;

struct CREATESTRUCTA
{
  LPVOID      lpCreateParams;
  HINSTANCE   hInstance;
  HMENU       hMenu;
  HWND        hwndParent;
  int         cy;
  int         cx;
  int         y;
  int         x;
  LONG        style;
  LPCSTR      lpszName;
  LPCSTR      lpszClass;
  DWORD       dwExStyle;
}
alias CREATESTRUCTA* LPCREATESTRUCTA;

version(unicode)
{
  alias CREATESTRUCTW CREATESTRUCT;
  alias LPCREATESTRUCTW LPCREATESTRUCT;
}
else
{
  alias CREATESTRUCTA CREATESTRUCT;
  alias LPCREATESTRUCTA LPCREATESTRUCT;
}

struct WINDOWPLACEMENT
{
  UINT  length;
  UINT  flags;
  UINT  showCmd;
  POINT ptMinPosition;
  POINT ptMaxPosition;
  RECT  rcNormalPosition;
}
alias WINDOWPLACEMENT* PWINDOWPLACEMENT;
alias WINDOWPLACEMENT* LPWINDOWPLACEMENT;

struct MSG
{
  HWND        hwnd;
  UINT        message;
  WPARAM      wParam;
  LPARAM      lParam;
  DWORD       time;
  POINT       pt;
}
alias MSG* PMSG;
alias MSG* NPMSG;
alias MSG* LPMSG;

enum
{
  SW_HIDE            = 0,
  SW_SHOWNORMAL      = 1,
  SW_NORMAL          = 1,
  SW_SHOWMINIMIZED   = 2,
  SW_SHOWMAXIMIZED   = 3,
  SW_MAXIMIZE        = 3,
  SW_SHOWNOACTIVATE  = 4,
  SW_SHOW            = 5,
  SW_MINIMIZE        = 6,
  SW_SHOWMINNOACTIVE = 7,
  SW_SHOWNA          = 8,
  SW_RESTORE         = 9,
  SW_SHOWDEFAULT     = 10,
  SW_MAX             = 10,

  // Old ShowWindow() Commands
  HIDE_WINDOW        = 0,
  SHOW_OPENWINDOW    = 1,
  SHOW_ICONWINDOW    = 2,
  SHOW_FULLSCREEN    = 3,
  SHOW_OPENNOACTIVATE= 4,

  // Identifiers for the WM_SHOWWINDOW message
  SW_PARENTCLOSING   = 1,
  SW_OTHERZOOM       = 2,
  SW_PARENTOPENING   = 3,
  SW_OTHERUNZOOM     = 4,
}

// Virtual Keys, Standard Set
enum
{
  VK_LBUTTON       = 0x01,
  VK_RBUTTON       = 0x02,
  VK_CANCEL        = 0x03,
  VK_MBUTTON       = 0x04,    // NOT contiguous with L & RBUTTON

  VK_BACK          = 0x08,
  VK_TAB           = 0x09,

  VK_CLEAR         = 0x0C,
  VK_RETURN        = 0x0D,

  VK_SHIFT         = 0x10,
  VK_CONTROL       = 0x11,
  VK_MENU          = 0x12,
  VK_PAUSE         = 0x13,
  VK_CAPITAL       = 0x14,

  VK_ESCAPE        = 0x1B,

  VK_SPACE         = 0x20,
  VK_PRIOR         = 0x21,
  VK_NEXT          = 0x22,
  VK_END           = 0x23,
  VK_HOME          = 0x24,
  VK_LEFT          = 0x25,
  VK_UP            = 0x26,
  VK_RIGHT         = 0x27,
  VK_DOWN          = 0x28,
  VK_SELECT        = 0x29,
  VK_PRINT         = 0x2A,
  VK_EXECUTE       = 0x2B,
  VK_SNAPSHOT      = 0x2C,
  VK_INSERT        = 0x2D,
  VK_DELETE        = 0x2E,
  VK_HELP          = 0x2F,

// VK_0 thru VK_9 are the same as ASCII '0' thru '9' (0x30 - 0x39)
// VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' (0x41 - 0x5A)

  VK_LWIN          = 0x5B,
  VK_RWIN          = 0x5C,
  VK_APPS          = 0x5D,

  VK_NUMPAD0       = 0x60,
  VK_NUMPAD1       = 0x61,
  VK_NUMPAD2       = 0x62,
  VK_NUMPAD3       = 0x63,
  VK_NUMPAD4       = 0x64,
  VK_NUMPAD5       = 0x65,
  VK_NUMPAD6       = 0x66,
  VK_NUMPAD7       = 0x67,
  VK_NUMPAD8       = 0x68,
  VK_NUMPAD9       = 0x69,
  VK_MULTIPLY      = 0x6A,
  VK_ADD           = 0x6B,
  VK_SEPARATOR     = 0x6C,
  VK_SUBTRACT      = 0x6D,
  VK_DECIMAL       = 0x6E,
  VK_DIVIDE        = 0x6F,
  VK_F1            = 0x70,
  VK_F2            = 0x71,
  VK_F3            = 0x72,
  VK_F4            = 0x73,
  VK_F5            = 0x74,
  VK_F6            = 0x75,
  VK_F7            = 0x76,
  VK_F8            = 0x77,
  VK_F9            = 0x78,
  VK_F10           = 0x79,
  VK_F11           = 0x7A,
  VK_F12           = 0x7B,

  VK_NUMLOCK       = 0x90,
  VK_SCROLL        = 0x91,

/*
 * VK_L* & VK_R* - left and right Alt, Ctrl and Shift virtual keys.
 * Used only as parameters to GetAsyncKeyState() and GetKeyState().
 * No other API or message will distinguish left and right keys in this way.
 */
  VK_LSHIFT        = 0xA0,
  VK_RSHIFT        = 0xA1,
  VK_LCONTROL      = 0xA2,
  VK_RCONTROL      = 0xA3,
  VK_LMENU         = 0xA4,
  VK_RMENU         = 0xA5,
}

// PeekMessage() Options
enum
{
  PM_NOREMOVE         = 0x0000,
  PM_REMOVE           = 0x0001,
  PM_NOYIELD          = 0x0002,
}

LPSTR MAKEINTRESOURCEA(int i) { return cast(LPSTR)(cast(DWORD)(cast(WORD)(i))); }
LPSTR MAKEINTRESOURCE(int i) { return cast(LPSTR)(cast(DWORD)(cast(WORD)(i))); }

const LPSTR IDI_APPLICATION    = cast(LPSTR)(32512);
const LPSTR IDI_HAND           = cast(LPSTR)(32513);
const LPSTR IDI_QUESTION       = cast(LPSTR)(32514);
const LPSTR IDI_EXCLAMATION    = cast(LPSTR)(32515);
const LPSTR IDI_ASTERISK       = cast(LPSTR)(32516);
const LPSTR IDI_WINLOGO        = cast(LPSTR)(32517);
const LPSTR IDI_WARNING     = IDI_EXCLAMATION;
const LPSTR IDI_ERROR       = IDI_HAND;
const LPSTR IDI_INFORMATION = IDI_ASTERISK;

const LPSTR IDC_ARROW          = cast(LPSTR)(32512);
const LPSTR IDC_IBEAM          = cast(LPSTR)(32513);
const LPSTR IDC_WAIT           = cast(LPSTR)(32514);
const LPSTR IDC_CROSS          = cast(LPSTR)(32515);
const LPSTR IDC_UPARROW        = cast(LPSTR)(32516);
const LPSTR IDC_SIZE           = cast(LPSTR)(32640);
const LPSTR IDC_ICON           = cast(LPSTR)(32641);
const LPSTR IDC_SIZENWSE       = cast(LPSTR)(32642);
const LPSTR IDC_SIZENESW       = cast(LPSTR)(32643);
const LPSTR IDC_SIZEWE         = cast(LPSTR)(32644);
const LPSTR IDC_SIZENS         = cast(LPSTR)(32645);
const LPSTR IDC_SIZEALL        = cast(LPSTR)(32646);
const LPSTR IDC_NO             = cast(LPSTR)(32648);
const LPSTR IDC_APPSTARTING    = cast(LPSTR)(32650);
const LPSTR IDC_HELP           = cast(LPSTR)(32651);

/* // already in windows.d
enum
{
  MB_OK                      = 0x00000000L,
  MB_OKCANCEL                = 0x00000001L,
  MB_ABORTRETRYIGNORE        = 0x00000002L,
  MB_YESNOCANCEL             = 0x00000003L,
  MB_YESNO                   = 0x00000004L,
  MB_RETRYCANCEL             = 0x00000005L,

  MB_ICONHAND                = 0x00000010L,
  MB_ICONQUESTION            = 0x00000020L,
  MB_ICONEXCLAMATION         = 0x00000030L,
  MB_ICONASTERISK            = 0x00000040L,

  MB_USERICON                = 0x00000080L,
  MB_ICONWARNING             = MB_ICONEXCLAMATION,
  MB_ICONERROR               = MB_ICONHAND,

  MB_ICONINFORMATION         = MB_ICONASTERISK,
  MB_ICONSTOP                = MB_ICONHAND,

  MB_DEFBUTTON1              = 0x00000000L,
  MB_DEFBUTTON2              = 0x00000100L,
  MB_DEFBUTTON3              = 0x00000200L,
  MB_DEFBUTTON4              = 0x00000300L,

  MB_APPLMODAL               = 0x00000000L,
  MB_SYSTEMMODAL             = 0x00001000L,
  MB_TASKMODAL               = 0x00002000L,
  MB_HELP                    = 0x00004000L, // Help Button

  MB_NOFOCUS                 = 0x00008000L,
  MB_SETFOREGROUND           = 0x00010000L,
  MB_DEFAULT_DESKTOP_ONLY    = 0x00020000L,

  MB_TOPMOST                 = 0x00040000L,
  MB_RIGHT                   = 0x00080000L,
  MB_RTLREADING              = 0x00100000L,
}*/

extern(Windows) // User
{
  int wvsprintfA(LPSTR,LPCSTR,va_list arglist);
  int wvsprintfW(LPWSTR,LPCWSTR,va_list arglist);
  version(unicode)
  {
    int wvsprintf(LPWSTR s1,LPCWSTR s2,va_list arglist) { return wvsprintfW(s1,s2,arglist); }
  }
  else
  {
    int wvsprintf(LPSTR s1,LPCSTR s2,va_list arglist) { return wvsprintfA(s1,s2,arglist); }
  }

  int wsprintfA(LPSTR, LPCSTR, ...);
  int wsprintfW(LPWSTR, LPCWSTR, ...);
  version(unicode)
  {
    int wsprintf(LPWSTR s1,LPCWSTR s2, ...) { va_list arglist; return wvsprintfW(s1,s2,arglist); }
  }
  else
  {
    int wsprintf(LPSTR s1,LPCSTR s2, ...) { va_list arglist; return wvsprintfA(s1,s2,arglist); }
  }

  int MessageBoxA(HWND hWnd, LPCSTR lpText, LPCSTR lpCaption, UINT uType);
  int MessageBoxW(HWND hWnd, LPCWSTR lpText, LPCWSTR lpCaption, UINT uType);
  version(unicode)
  {
    int MessageBox(HWND hWnd, LPCWSTR lpText, LPCWSTR lpCaption, UINT uType)
    {
      return MessageBoxW(hWnd,lpText,lpCaption,uType);
    }
  }
  else
  {
    int MessageBox(HWND hWnd, LPCSTR lpText, LPCSTR lpCaption, UINT uType)
    {
      return MessageBoxA(hWnd,lpText,lpCaption,uType);
    }
  }

  HWND SetFocus(HWND hWnd);
  HWND GetActiveWindow();
  HWND GetFocus();

  SHORT GetKeyState(int nVirtKey);
  SHORT GetAsyncKeyState(int vKey);
  BOOL GetKeyboardState(PBYTE lpKeyState);

  BOOL GetMessageA(LPMSG lpMsg,HWND hWnd, UINT wMsgFilterMin,UINT wMsgFilterMax);
  BOOL GetMessageW(LPMSG lpMsg,HWND hWnd, UINT wMsgFilterMin,UINT wMsgFilterMax);
  version(unicode)
  {
    BOOL GetMessage(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax)
    {
      return GetMessageW(lpMsg,hWnd,wMsgFilterMin,wMsgFilterMax);
    }
  }
  else
  {
    BOOL GetMessage(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax)
    {
      return GetMessageA(lpMsg,hWnd,wMsgFilterMin,wMsgFilterMax);
    }
  }

  BOOL TranslateMessage(MSG *lpMsg);

  LONG DispatchMessageA(MSG *lpMsg);
  LONG DispatchMessageW(MSG *lpMsg);
  version(unicode)
  {
    LONG DispatchMessage(MSG *lpMsg)
    {
      return DispatchMessageW(lpMsg);
    }
  }
  else
  {
    LONG DispatchMessage(MSG *lpMsg)
    {
      return DispatchMessageA(lpMsg);
    }
  }

  BOOL SetMessageQueue(int cMessagesMax);

  BOOL PeekMessageA(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);
  BOOL PeekMessageW(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);
  version(unicode)
  {
    BOOL PeekMessage(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg)
    {
      return PeekMessageW(lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax, wRemoveMsg);
    }
  }
  else
  {
    BOOL PeekMessage(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg)
    {
      return PeekMessageA(lpMsg, hWnd, wMsgFilterMin, wMsgFilterMax, wRemoveMsg);
    }
  }

  LRESULT DefWindowProcA(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);
  LRESULT DefWindowProcW(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);
  version(unicode)
  {
    LRESULT DefWindowProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
    {
      return DefWindowProcW(hWnd, Msg, wParam, lParam);
    }
  }
  else
  {
    LRESULT DefWindowProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
    {
      return DefWindowProcA(hWnd, Msg, wParam, lParam);
    }
  }

  BOOL PostMessageA(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);
  BOOL PostMessageW(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);
  version(unicode)
  {
    BOOL PostMessage(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
    {
      return PostMessageW(hWnd, Msg, wParam, lParam);
    }
  }
  else
  {
    BOOL PostMessage(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
    {
      return PostMessageA(hWnd, Msg, wParam, lParam);
    }
  }
  VOID PostQuitMessage(int nExitCode);

  ATOM RegisterClassA(WNDCLASSA* lpWndClass);
  ATOM RegisterClassW(WNDCLASSW* lpWndClass);
  version(unicode)
  {
    ATOM RegisterClass(WNDCLASSW* lpWndClass) { return RegisterClassW(lpWndClass); }
  }
  else
  {
    ATOM RegisterClass(WNDCLASSA* lpWndClass) { return RegisterClassA(lpWndClass); }
  }
  BOOL GetClassInfoA(HINSTANCE hInstance, LPCSTR lpClassName, LPWNDCLASSA lpWndClass);
  HWND CreateWindowExA(DWORD dwExStyle, LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle,
    int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam);
  HWND CreateWindowExW(DWORD dwExStyle, LPCWSTR lpClassName, LPCWSTR lpWindowName, DWORD dwStyle,
    int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam);
  version(unicode)
  {
    HWND CreateWindowEx(DWORD dwExStyle, LPCWSTR lpClassName, LPCWSTR lpWindowName, DWORD dwStyle,
      int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam)
    {
      return CreateWindowExW(dwExStyle,lpClassName,lpWindowName,dwStyle,X,Y,nWidth,nHeight,hWndParent,hMenu,hInstance,lpParam);
    }
  }
  else
  {
    HWND CreateWindowEx(DWORD dwExStyle, LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle,
      int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam)
    {
      return CreateWindowExA(dwExStyle,lpClassName,lpWindowName,dwStyle,X,Y,nWidth,nHeight,hWndParent,hMenu,hInstance,lpParam);
    }
  }

  BOOL IsWindow(HWND hWnd);
  BOOL IsMenu(HMENU hMenu);
  BOOL IsChild(HWND hWndParent,HWND hWnd);

  BOOL DestroyWindow(HWND hWnd);
  BOOL ShowWindow(HWND hWnd,int nCmdShow);

  BOOL InvalidateRect(HWND hWnd, RECT* lpRect, BOOL bErase);
  BOOL ValidateRect(HWND hWnd, RECT *lpRect);

  BOOL GetClientRect(HWND hWnd, LPRECT lpRect);
  BOOL GetWindowRect(HWND hWnd, LPRECT lpRect);
  BOOL AdjustWindowRect(LPRECT lpRect, DWORD dwStyle, BOOL bMenu);

  HBITMAP LoadBitmapA(HINSTANCE hInstance, LPCSTR lpBitmapName);
  HBITMAP LoadBitmapW(HINSTANCE hInstance, LPCWSTR lpBitmapName);
  version(unicode)
  {
    HBITMAP LoadBitmap(HINSTANCE hInstance, LPCWSTR lpBitmapName)
    {
      return LoadBitmapW(hInstance, lpBitmapName);
    }
  }
  else
  {
    HBITMAP LoadBitmap(HINSTANCE hInstance, LPCSTR lpBitmapName)
    {
      return LoadBitmapA(hInstance, lpBitmapName);
    }
  }

  HICON LoadIconA(HINSTANCE hInstance, LPCSTR lpIconName);
  HICON LoadIconW(HINSTANCE hInstance, LPCWSTR lpIconName);
  version(unicode)
  {
    HICON LoadIcon(HINSTANCE hInstance, LPCWSTR lpIconName)
    {
      return LoadIconW(hInstance, lpIconName);
    }
  }
  else
  {
    HICON LoadIcon(HINSTANCE hInstance, LPCSTR lpIconName)
    {
      return LoadIconA(hInstance, lpIconName);
    }
  }
  HCURSOR LoadCursorA(HINSTANCE hInstance, LPCSTR lpCursorName);
  HCURSOR LoadCursorW(HINSTANCE hInstance, LPCWSTR lpCursorName);
  version(unicode)
  {
    HCURSOR LoadCursor(HINSTANCE hInstance, LPCWSTR lpCursorName)
    {
      return LoadCursorW(hInstance, lpCursorName);
    }
  }
  else
  {
    HCURSOR LoadCursor(HINSTANCE hInstance, LPCSTR lpCursorName)
    {
      return LoadCursorA(hInstance, lpCursorName);
    }
  }
}


